////////////////////////////////////////////////////////////////////////
// setup.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.setup")

// <%pre>
#line 1 "setup.ecpp"


#include <setup.h>
#include <tools.h>
#include <users.h>
#include <live.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("setup");

static const char* rawData = "D\001\000\000\257\001\000\000\272\001\000\000\275\001\000\000\322\004\000\000\325\004\000"
  "\000L\005\000\000\220\005\000\000M\006\000\000\262\006\000\000\037\007\000\000\376\007\000\000>\010\000\000\276\010"
  "\000\000\002\t\000\000\226\t\000\000\377\t\000\000G\n\000\000\347\n\000\000V\013\000\000\270\013\000\0004\014\000\000"
  "\220\014\000\000\007\015\000\000\360\015\000\000Z\016\000\000\257\016\000\000\031\017\000\000n\017\000\000\330\017"
  "\000\000-\020\000\000\227\020\000\000\354\020\000\000G\021\000\000\234\021\000\000\013\022\000\0005\022\000\000_\022"
  "\000\000\210\022\000\000\262\022\000\000\250\023\000\000v\024\000\000\037\025\000\000\216\025\000\000\352\025\000\000"
  "o\026\000\000\313\026\000\000*\027\000\000\222\027\000\000\341\027\000\000\370\027\000\000K\030\000\000\242\030\000"
  "\000\301\030\000\000\024\031\000\000\202\031\000\000\367\031\000\000\202\032\000\000\337\032\000\000_\033\000\000`"
  "\033\000\000\215\033\000\000\216\033\000\000\270\033\000\000\271\033\000\000\350\033\000\000\351\033\000\000\025\034"
  "\000\000\026\034\000\000>\034\000\000\?\034\000\000\253\034\000\000\375\034\000\000\023\035\000\000\025\035\000\000"
  "\026\035\000\000 \035\000\000\350\035\000\000J\036\000\000K\036\000\000L\036\000\000\n<html>\n\t<head>\n<meta name=\""
  "viewport\" content=\"width=device-width, initial-scale=1\" />\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t\t<scrip"
  "t type=\"text/javascript\"><!--\n\t\tfunction initform()\n\t\t{\n\t\t\tchangeduseauth(document.getElementById(\"useau"
  "th\"));\n\t\t\tchangedusestreamdev(document.getElementById(\"useStreamdev\"));\n\t\t\tif (document.getElementById(\"m"
  "essage\").value != \"\")\n\t\t\t\talert(document.getElementById(\"message\").value);\n\t\t}\n\t\tfunction changedusea"
  "uth(selection)\n\t\t{\n\t\t\tdocument.getElementById(\"authsection\").style.display = (selection.checked \? \"block\""
  " : \"none\");\n\t\t}\n\t\tfunction setauthchanged(selection)\n\t\t{\n\t\t\tdocument.getElementById(\"authchanged\").v"
  "alue = 1;\n\t\t}\n\t\tfunction changedusestreamdev(selection)\n\t\t{\n\t\t\tdocument.getElementById(\"streamdevsectio"
  "n\").style.display = (selection.checked \? \"block\" : \"none\");\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onlo"
  "ad=\"initform(); adjustHeader()\" onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<form m"
  "ethod=\"post\" action=\"setup.html\">\n\t\t\t\t<input type=\"hidden\" name=\"authchanged\" value=\"\" id=\"authchange"
  "d\"/>\n\t\t\t\t<input type=\"hidden\" name=\"message\" value=\"\" id=\"message\"/>\n\t\t\t\t<table class=\"formular\""
  " cellpadding=\"0\" cellspacing=\"0\">\n\t\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t\t<td  class=\"toprow leftcol rightco"
  "l\" colspan=\"2\"><div class=\"boxheader\"><div><div></div></div></div></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t"
  "\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t"
  "\t\t\t\t<input type=\"checkbox\" name=\"useauth\" id=\"useauth\" value=\"1\" onclick=\"changeduseauth(this)\"/>\n\t\t"
  "\t\t\t\t\t<div id=\"authsection\" style=\"display: none\">\n\t\t\t\t\t\t\t<table border=\"0\" cellpadding=\"0\" cells"
  "pacing=\"0\" class=\"dependent\">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">"
  ":</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"login\" value=\"\" id=\"login\" onchange=\"setauthchang"
  "ed(this)\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmar"
  "gin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input  type=\"password\" name=\"pass\" value=\"\" id=\"pass\" onchange=\"set"
  "authchanged(this)\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class="
  "\"withmargin\"><a href=\"users.html\"></a></div></td>\n\t\t\t\t\t\t\t\t<td/>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>"
  "\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input  type=\"text"
  "\" name=\"localnetmask\" value=\"\" id=\"localnetmask\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t"
  "\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div clas"
  "s=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"sho"
  "wLogo\" id=\"showLogo\" value=\"1\" />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n            <td class=\"l"
  "abel leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n              <input type"
  "=\"checkbox\" name=\"showInfoBox\" id=\"showInfoBox\" value=\"1\" />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<"
  "tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol"
  "\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"useStreamdev\" id=\"useStreamdev\" value=\"1\" onclick=\"changedus"
  "estreamdev(this)\"/>\n\t\t\t\t\t\t\t<div id=\"streamdevsection\" style=\"display: none\">\n\t\t\t\t\t\t\t<table borde"
  "r=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"dependent\">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"lab"
  "el\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamVideoOpt0\" id=\"s"
  "treamVideoOpt0\" size=\"100\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="
  "\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamVideoOpt1\" i"
  "d=\"streamVideoOpt1\" size=\"100\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td c"
  "lass=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamVideoOpt"
  "2\" id=\"streamVideoOpt2\" size=\"100\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t"
  "<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamVid"
  "eoOpt3\" id=\"streamVideoOpt3\" size=\"100\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t"
  "\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"str"
  "eamdevport\" id=\"streamdevport\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td cl"
  "ass=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><select name=\"streamdevtype\" size=\"1\" i"
  "d=\"streamdevtype\">\n\t\t\t\t\t\t\t\t\t<option value=\"TS\" >TS</option>\n\t\t\t\t\t\t\t\t\t<option value=\"PES\" >P"
  "ES</option>\n\t\t\t\t\t\t\t\t\t<option value=\"PS\" >PS</option>\n\t\t\t\t\t\t\t\t\t<option value=\"ES\" >ES</option>"
  "\n\t\t\t\t\t\t\t\t\t<option value=\"EXT\" >EXT</option>\n\t\t\t\t\t\t\t\t</select></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t"
  "\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n                                        <"
  "tr>\n                                                <td class=\"label leftcol\"><div class=\"withmargin\">:</div></t"
  "d>\n                                                <td class=\"rightcol\">\n                                        "
  "                <input type=\"checkbox\" name=\"markNewRec\" id=\"markNewRec\" value=\"1\" />\n                      "
  "                          </td>\n                                        </tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class"
  "=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input "
  "type=\"checkbox\" name=\"showIMDb\" id=\"showIMDb\" value=\"1\" />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr"
  ">\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\""
  ">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"showPlayMediaplayer\" id=\"showPlayMediaplayer\" value=\"1\" />\n\t"
  "\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:"
  "</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"number\" min=\"0\" name=\"lastchannel\" value=\"\" id="
  "\"lastchannel\" /></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withma"
  "rgin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" name=\"times\" value=\"\" id=\"times\" /"
  ">\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmar"
  "gin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" name=\"channelGroups\" value=\"\" id=\"ch"
  "annelGroups\" />\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div "
  "class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"number\" min=\"1\" max= \"23\" na"
  "me=\"scheduleDuration\" value=\"\" id=\"scheduleDuration\" />\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n"
  "\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n"
  "\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"showChannelsWithoutEPG\" id=\"showChannelsWithoutEPG\" value=\"1\" />\n"
  "\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin"
  "\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><select name=\"startscreen\" size=\"1\" id=\"startscreen\">\n\t\t"
  "\t\t\t\t\t<option value=\"whatsonnow\" ></option>\n\t\t\t\t\t\t\t<option value=\"whatsonnext\" ></option>\n\t\t\t\t\t"
  "\t\t<option value=\"schedule\" ></option>\n\t\t\t\t\t\t\t<option value=\"multischedule\" ></option>\n\t\t\t\t\t\t\t<o"
  "ption value=\"recordings\" ></option>\n\t\t\t\t\t\t\t<option value=\"timers\" ></option>\n\t\t\t\t\t\t</select></td>"
  "\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t"
  "\t\t\t\t\t<td class=\"rightcol\"><select name=\"theme\" size=\"1\" id=\"theme\">\n\t\t\t\t\t\t\t<option value=\"\" ><"
  "/option>\n\t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"buttonpanel leftcol ri"
  "ghtcol bottomrow\" colspan=\"2\">\n\t\t\t\t\t\t\t<div class=\"withmargin\">\n\t\t\t\t\t\t\t<button class=\"green\" ty"
  "pe=\"submit\" name=\"save\" ></button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n"
  "\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("setup " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string lastchannel = qparam.get< std::string >("lastchannel");
bool useauth = qparam.get< bool >("useauth", ( false));
std::string login = qparam.get< std::string >("login");
std::string pass = qparam.get< std::string >("pass");
std::string times = qparam.get< std::string >("times");
std::string channelGroups = qparam.get< std::string >("channelGroups");
std::string scheduleDuration = qparam.get< std::string >("scheduleDuration");
std::string startscreen = qparam.get< std::string >("startscreen");
std::string theme = qparam.get< std::string >("theme");
std::string localnetmask = qparam.get< std::string >("localnetmask");
std::string showLogo = qparam.get< std::string >("showLogo");
std::string showInfoBox = qparam.get< std::string >("showInfoBox");
std::string useStreamdev = qparam.get< std::string >("useStreamdev");
std::string markNewRec = qparam.get< std::string >("markNewRec");
std::string showIMDb = qparam.get< std::string >("showIMDb");
std::string showPlayMediaplayer = qparam.get< std::string >("showPlayMediaplayer");
std::string showChannelsWithoutEPG = qparam.get< std::string >("showChannelsWithoutEPG");
std::string streamdevport = qparam.get< std::string >("streamdevport");
std::string streamdevtype = qparam.get< std::string >("streamdevtype");
std::string streamVideoOpt0 = qparam.get< std::string >("streamVideoOpt0");
std::string streamVideoOpt1 = qparam.get< std::string >("streamVideoOpt1");
std::string streamVideoOpt2 = qparam.get< std::string >("streamVideoOpt2");
std::string streamVideoOpt3 = qparam.get< std::string >("streamVideoOpt3");
int authchanged = qparam.get< int >("authchanged", ( 0));
  // </%args>

#line 38 "setup.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 41 "setup.ecpp"

if (!logged_in && LiveSetup().UseAuth() ) return reply.redirect("login.html");
if (!cUser::CurrentUserHasRightTo(UR_EDITSETUP))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

#define SELECTIF(x) reply.out() << ( (x) ? "selected=\"selected\"" : "" );
#define CHECKIF(x) reply.out() << ( (x) ? "checked=\"checked\"" : "" );

	std::string message;

	if ( request.getMethod() == "POST") {
		if (authchanged && useauth && (login.empty() || pass.empty()))
			message = tr("Please set login and password!");
		else
		{
			LiveSetup().SetLastChannel(lastchannel != "" ? lexical_cast< int >(lastchannel):0);
			LiveSetup().SetUseAuth(useauth);
			if (useauth) {
				LiveSetup().SetAdminLogin(login);
				if (pass != "")
					LiveSetup().SetAdminPassword(pass);
				LiveSetup().SetLocalNetMask(localnetmask);
				LiveSetup().CheckLocalNet(request.getPeerIp());
			}
			LiveSetup().SetTimes(times);
			LiveSetup().SetChannelGroups(channelGroups);
			LiveSetup().SetScheduleDuration(scheduleDuration);
			LiveSetup().SetStartScreen(startscreen);
			LiveSetup().SetTheme(theme);
			LiveSetup().SetShowLogo(!showLogo.empty());
			LiveSetup().SetShowInfoBox(!showInfoBox.empty());
			LiveSetup().SetUseStreamdev(!useStreamdev.empty());
			LiveSetup().SetStreamdevPort(streamdevport.empty() ? 3000 : lexical_cast<int>(streamdevport));
			LiveSetup().SetStreamdevType(streamdevtype.empty() ? "PES" : streamdevtype);
			LiveSetup().SetMarkNewRec(!markNewRec.empty());

			std::string def = "ffmpeg -loglevel warning -f mpegts -analyzeduration 1.2M -probesize 5M "
				"-i <input> -map 0:v -map 0:a:0 -c:v copy -c:a aac -ac 2";
			LiveSetup().SetStreamVideoOpt0(streamVideoOpt0.empty() ? def : streamVideoOpt0);
			LiveSetup().SetStreamVideoOpt1(streamVideoOpt1.empty() ? def : streamVideoOpt1);
			LiveSetup().SetStreamVideoOpt2(streamVideoOpt2.empty() ? def : streamVideoOpt2);
			LiveSetup().SetStreamVideoOpt3(streamVideoOpt3.empty() ? def : streamVideoOpt3);

			LiveSetup().SetShowIMDb(!showIMDb.empty());
			LiveSetup().SetShowPlayMediaplayer(!showPlayMediaplayer.empty());
			LiveSetup().SetShowChannelsWithoutEPG(!showChannelsWithoutEPG.empty());
			LiveSetup().SaveSetup();

			message = tr("Setup saved.");
		}
	}
	pageTitle = tr("Setup");
	int ilastchannel = LiveSetup().GetLastChannel();
	if (ilastchannel == std::numeric_limits< int >::max())
		lastchannel = "";
	else
		lastchannel = lexical_cast<std::string, int>(ilastchannel);

	login = LiveSetup().GetAdminLogin();
	useauth = LiveSetup().GetUseAuth();
	times = LiveSetup().GetTimes();
	channelGroups = LiveSetup().GetChannelGroups();
	scheduleDuration = LiveSetup().GetScheduleDuration();
	startscreen = LiveSetup().GetStartScreen();
	theme = LiveSetup().GetTheme();
	localnetmask = LiveSetup().GetLocalNetMask();
	showLogo = LiveSetup().GetShowLogo() ? "1" : "";
	showInfoBox = LiveSetup().GetShowInfoBox() ? "1" : "";
	useStreamdev = LiveSetup().GetUseStreamdev() ? "1" : "";
	streamdevport = lexical_cast<std::string, int>(LiveSetup().GetStreamdevPort());
	streamdevtype = LiveSetup().GetStreamdevType();
	markNewRec = LiveSetup().GetMarkNewRec() ? "1" : "";
	streamVideoOpt0 = LiveSetup().GetStreamVideoOpt0();
	streamVideoOpt1 = LiveSetup().GetStreamVideoOpt1();
	streamVideoOpt2 = LiveSetup().GetStreamVideoOpt2();
	streamVideoOpt3 = LiveSetup().GetStreamVideoOpt3();
	showIMDb = LiveSetup().GetShowIMDb() ? "1" : "";
	showPlayMediaplayer = LiveSetup().GetShowPlayMediaplayer() ? "1" : "";
	showChannelsWithoutEPG = LiveSetup().GetShowChannelsWithoutEPG() ? "1" : "";

  // <& pageelems.doc_type ...
  { 
#line 121 "setup.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 121 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n\t<head>\n<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR-Live - 
#line 125 "setup.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 126 "setup.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 126 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 127 "setup.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 127 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n\t\t<script type="text/javascript"><!--\n\t\tfunction initform()\n\t\t{\n\t\t\tchangeduseauth(document.getElementById("useauth"));\n\t\t\tchangedusestreamdev(document.getElementById("useStreamdev"));\n\t\t\tif (document.getElementById("message").value != "")\n\t\t\t\talert(document.getElementById("message").value);\n\t\t}\n\t\tfunction changeduseauth(selection)\n\t\t{\n\t\t\tdocument.getElementById("authsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\tfunction setauthchanged(selection)\n\t\t{\n\t\t\tdocument.getElementById("authchanged").value = 1;\n\t\t}\n\t\tfunction changedusestreamdev(selection)\n\t\t{\n\t\t\tdocument.getElementById("streamdevsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload="initform(); adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 151 "setup.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 151 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n\t\t
  // <& menu ...
  { 
#line 152 "setup.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 152 "setup.ecpp"
    _tnt_cq4.add( "active", ("setup"));
#line 152 "setup.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t<div class="inhalt">\n\t\t\t<form method="post" action="setup.html">\n\t\t\t\t<input type="hidden" name="authchanged" value="
#line 155 "setup.ecpp"
  reply.sout() << ( authchanged );
  reply.out() << _tntChunks[6]; // " id="authchanged"/>\n\t\t\t\t<input type="hidden" name="message" value="
#line 156 "setup.ecpp"
  reply.sout() << ( message );
  reply.out() << _tntChunks[7]; // " id="message"/>\n\t\t\t\t<table class="formular" cellpadding="0" cellspacing="0">\n\t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t<td  class="toprow leftcol rightcol" colspan="2"><div class="boxheader"><div><div>
#line 159 "setup.ecpp"
  reply.sout() << ( tr("Setup") );
  reply.out() << _tntChunks[8]; // </div></div></div></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 162 "setup.ecpp"
  reply.sout() << ( tr("Use authentication") );
  reply.out() << _tntChunks[9]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useauth" id="useauth" value="1" 
#line 164 "setup.ecpp"
 CHECKIF(useauth); 
  reply.out() << _tntChunks[10]; // onclick="changeduseauth(this)"/>\n\t\t\t\t\t\t\t<div id="authsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 168 "setup.ecpp"
  reply.sout() << ( tr("Admin login") );
  reply.out() << _tntChunks[11]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="login" value="
#line 169 "setup.ecpp"
  reply.sout() << ( login );
  reply.out() << _tntChunks[12]; // " id="login" onchange="setauthchanged(this)" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 172 "setup.ecpp"
  reply.sout() << ( tr("Admin password") );
  reply.out() << _tntChunks[13]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input  type="password" name="pass" value="
#line 173 "setup.ecpp"
  reply.sout() << ( pass );
  reply.out() << _tntChunks[14]; // " id="pass" onchange="setauthchanged(this)" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin"><a href="users.html">
#line 176 "setup.ecpp"
  reply.sout() << ( tr("User management") );
  reply.out() << _tntChunks[15]; // </a></div></td>\n\t\t\t\t\t\t\t\t<td/>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 180 "setup.ecpp"
  reply.sout() << ( tr("Local net (no login required)") );
  reply.out() << _tntChunks[16]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input  type="text" name="localnetmask" value="
#line 181 "setup.ecpp"
  reply.sout() << ( localnetmask );
  reply.out() << _tntChunks[17]; // " id="localnetmask" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 188 "setup.ecpp"
  reply.sout() << ( tr("Show live logo image") );
  reply.out() << _tntChunks[18]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showLogo" id="showLogo" value="1" 
#line 190 "setup.ecpp"
 CHECKIF(!showLogo.empty()); 
  reply.out() << _tntChunks[19]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n            <td class="label leftcol"><div class="withmargin">
#line 194 "setup.ecpp"
  reply.sout() << ( tr("Show dynamic VDR information box") );
  reply.out() << _tntChunks[20]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n              <input type="checkbox" name="showInfoBox" id="showInfoBox" value="1" 
#line 196 "setup.ecpp"
 CHECKIF(!showInfoBox.empty()); 
  reply.out() << _tntChunks[21]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 200 "setup.ecpp"
  reply.sout() << ( tr("Allow video streaming") );
  reply.out() << _tntChunks[22]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useStreamdev" id="useStreamdev" value="1" 
#line 202 "setup.ecpp"
 CHECKIF(!useStreamdev.empty()); 
  reply.out() << _tntChunks[23]; // onclick="changedusestreamdev(this)"/>\n\t\t\t\t\t\t\t<div id="streamdevsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 206 "setup.ecpp"
  reply.sout() << ( tr("Web-Streaming h264") );
  reply.out() << _tntChunks[24]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamVideoOpt0" id="streamVideoOpt0" size="100" value="
#line 207 "setup.ecpp"
  reply.sout() << ( streamVideoOpt0 );
  reply.out() << _tntChunks[25]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 210 "setup.ecpp"
  reply.sout() << ( tr("Web-Streaming HEVC") );
  reply.out() << _tntChunks[26]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamVideoOpt1" id="streamVideoOpt1" size="100" value="
#line 211 "setup.ecpp"
  reply.sout() << ( streamVideoOpt1 );
  reply.out() << _tntChunks[27]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 214 "setup.ecpp"
  reply.sout() << ( tr("Web-Streaming MPEG2") );
  reply.out() << _tntChunks[28]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamVideoOpt2" id="streamVideoOpt2" size="100" value="
#line 215 "setup.ecpp"
  reply.sout() << ( streamVideoOpt2 );
  reply.out() << _tntChunks[29]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 218 "setup.ecpp"
  reply.sout() << ( tr("Web-Streaming others") );
  reply.out() << _tntChunks[30]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamVideoOpt3" id="streamVideoOpt3" size="100" value="
#line 219 "setup.ecpp"
  reply.sout() << ( streamVideoOpt3 );
  reply.out() << _tntChunks[31]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 222 "setup.ecpp"
  reply.sout() << ( tr("Streamdev server port") );
  reply.out() << _tntChunks[32]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamdevport" id="streamdevport" value="
#line 223 "setup.ecpp"
  reply.sout() << ( streamdevport );
  reply.out() << _tntChunks[33]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 226 "setup.ecpp"
  reply.sout() << ( tr("Streamdev stream type") );
  reply.out() << _tntChunks[34]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><select name="streamdevtype" size="1" id="streamdevtype">\n\t\t\t\t\t\t\t\t\t<option value="TS" 
#line 228 "setup.ecpp"
 SELECTIF(streamdevtype == "TS") 
  reply.out() << _tntChunks[35]; // >TS</option>\n\t\t\t\t\t\t\t\t\t<option value="PES" 
#line 229 "setup.ecpp"
 SELECTIF(streamdevtype == "PES") 
  reply.out() << _tntChunks[36]; // >PES</option>\n\t\t\t\t\t\t\t\t\t<option value="PS" 
#line 230 "setup.ecpp"
 SELECTIF(streamdevtype == "PS") 
  reply.out() << _tntChunks[37]; // >PS</option>\n\t\t\t\t\t\t\t\t\t<option value="ES" 
#line 231 "setup.ecpp"
 SELECTIF(streamdevtype == "ES") 
  reply.out() << _tntChunks[38]; // >ES</option>\n\t\t\t\t\t\t\t\t\t<option value="EXT" 
#line 232 "setup.ecpp"
 SELECTIF(streamdevtype == "EXT") 
  reply.out() << _tntChunks[39]; // >EXT</option>\n\t\t\t\t\t\t\t\t</select></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n                                        <tr>\n                                                <td class="label leftcol"><div class="withmargin">
#line 240 "setup.ecpp"
  reply.sout() << ( tr("Mark new recordings") );
  reply.out() << _tntChunks[40]; // :</div></td>\n                                                <td class="rightcol">\n                                                        <input type="checkbox" name="markNewRec" id="markNewRec" value="1" 
#line 242 "setup.ecpp"
 CHECKIF(!markNewRec.empty()); 
  reply.out() << _tntChunks[41]; // />\n                                                </td>\n                                        </tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 246 "setup.ecpp"
  reply.sout() << ( tr("Show link to IMDb in list views") );
  reply.out() << _tntChunks[42]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showIMDb" id="showIMDb" value="1" 
#line 248 "setup.ecpp"
 CHECKIF(!showIMDb.empty()); 
  reply.out() << _tntChunks[43]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 252 "setup.ecpp"
  reply.sout() << ( tr("Show \"Play in Mediaplayer\" in list views") );
  reply.out() << _tntChunks[44]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showPlayMediaplayer" id="showPlayMediaplayer" value="1" 
#line 254 "setup.ecpp"
 CHECKIF(!showPlayMediaplayer.empty()); 
  reply.out() << _tntChunks[45]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 258 "setup.ecpp"
  reply.sout() << ( tr("Last channel to display") );
  reply.out() << _tntChunks[46]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="number" min="0" name="lastchannel" value="
#line 259 "setup.ecpp"
  reply.sout() << ( lastchannel );
  reply.out() << _tntChunks[47]; // " id="lastchannel" /></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 262 "setup.ecpp"
  reply.sout() << ( tr("Additional fixed times in 'What's on?'") );
  reply.out() << _tntChunks[48]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="times" value="
#line 263 "setup.ecpp"
  reply.sout() << ( times );
  reply.out() << _tntChunks[49]; // " id="times" />\n\t\t\t\t\t\t\t
  // <& tooltip.help ...
  { 
#line 264 "setup.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 264 "setup.ecpp"
    _tnt_cq5.add( "text", (tr("Format is HH:MM. Separate multiple times with a semicolon")));
#line 264 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[50]; // </td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 267 "setup.ecpp"
  reply.sout() << ( tr("Channel groups for MultiSchedule") );
  reply.out() << _tntChunks[51]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="channelGroups" value="
#line 268 "setup.ecpp"
  reply.sout() << ( channelGroups );
  reply.out() << _tntChunks[52]; // " id="channelGroups" />\n\t\t\t\t\t\t\t
  // <& tooltip.help ...
  { 
#line 269 "setup.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 269 "setup.ecpp"
    _tnt_cq6.add( "text", (tr("Separate channels with a comma ',', separate groups with a semi-colon ';'")));
#line 269 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[53]; // </td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 272 "setup.ecpp"
  reply.sout() << ( tr("Duration of MultiSchedule in hours") );
  reply.out() << _tntChunks[54]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="number" min="1" max= "23" name="scheduleDuration" value="
#line 273 "setup.ecpp"
  reply.sout() << ( scheduleDuration );
  reply.out() << _tntChunks[55]; // " id="scheduleDuration" />\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 277 "setup.ecpp"
  reply.sout() << ( tr("Show channels without EPG") );
  reply.out() << _tntChunks[56]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showChannelsWithoutEPG" id="showChannelsWithoutEPG" value="1" 
#line 279 "setup.ecpp"
 CHECKIF(!showChannelsWithoutEPG.empty()); 
  reply.out() << _tntChunks[57]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 284 "setup.ecpp"
  reply.sout() << ( tr("Start page") );
  reply.out() << _tntChunks[58]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><select name="startscreen" size="1" id="startscreen">\n\t\t\t\t\t\t\t<option value="whatsonnow" 
#line 286 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnow") 
  reply.out() << _tntChunks[59]; // >
#line 286 "setup.ecpp"
  reply.sout() << ( trVDR("What's on now?") );
  reply.out() << _tntChunks[60]; // </option>\n\t\t\t\t\t\t\t<option value="whatsonnext" 
#line 287 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnext") 
  reply.out() << _tntChunks[61]; // >
#line 287 "setup.ecpp"
  reply.sout() << ( trVDR("What's on next?") );
  reply.out() << _tntChunks[62]; // </option>\n\t\t\t\t\t\t\t<option value="schedule" 
#line 288 "setup.ecpp"
 SELECTIF(startscreen == "schedule") 
  reply.out() << _tntChunks[63]; // >
#line 288 "setup.ecpp"
  reply.sout() << ( trVDR("Schedule") );
  reply.out() << _tntChunks[64]; // </option>\n\t\t\t\t\t\t\t<option value="multischedule" 
#line 289 "setup.ecpp"
 SELECTIF(startscreen == "multischedule") 
  reply.out() << _tntChunks[65]; // >
#line 289 "setup.ecpp"
  reply.sout() << ( tr("MultiSchedule") );
  reply.out() << _tntChunks[66]; // </option>\n\t\t\t\t\t\t\t<option value="recordings" 
#line 290 "setup.ecpp"
 SELECTIF(startscreen == "recordings") 
  reply.out() << _tntChunks[67]; // >
#line 290 "setup.ecpp"
  reply.sout() << ( trVDR("Recordings") );
  reply.out() << _tntChunks[68]; // </option>\n\t\t\t\t\t\t\t<option value="timers" 
#line 291 "setup.ecpp"
 SELECTIF(startscreen == "timers") 
  reply.out() << _tntChunks[69]; // >
#line 291 "setup.ecpp"
  reply.sout() << ( trVDR("Timers") );
  reply.out() << _tntChunks[70]; // </option>\n\t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 295 "setup.ecpp"
  reply.sout() << ( tr("Theme") );
  reply.out() << _tntChunks[71]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><select name="theme" size="1" id="theme">\n
#line 297 "setup.ecpp"

{
	const std::string dirPath(Plugin::GetResourceDirectory() + "/themes");
	cReadDir d(dirPath.c_str());
	struct dirent* e;
	std::string parent("..");
	std::string current(".");
	std::string cvsDir("CVS");
	while ((e = d.Next())) {
		if ((current == e->d_name) || (parent == e->d_name) || (cvsDir == e->d_name)) {
			continue;
		}
		/* Check if entry is a directory: I do not rely on e->d_type
		   here because on some systems it is allways DT_UNKNOWN. Also
		   testing for DT_DIR does not take into account symbolic
		   links to directories.
		*/
		struct stat buf;
		if ((stat((dirPath + "/" + e->d_name).c_str(), &buf) != 0) || (!S_ISDIR(buf.st_mode))) {
			continue;
		}

  reply.out() << _tntChunks[72]; // \t\t\t\t\t\t\t<option value="
#line 319 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << _tntChunks[73]; // " 
#line 319 "setup.ecpp"
 SELECTIF(theme == e->d_name) 
  reply.out() << _tntChunks[74]; // >
#line 319 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << _tntChunks[75]; // </option>\n
#line 320 "setup.ecpp"

	}
}

  reply.out() << _tntChunks[76]; // \t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="buttonpanel leftcol rightcol bottomrow" colspan="2">\n\t\t\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t\t<button class="green" type="submit" name="save" >
#line 329 "setup.ecpp"
  reply.sout() << ( tr("Save") );
  reply.out() << _tntChunks[77]; // </button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[78]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[79]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
